]> git.madduck.net Git - code/vcsh.git/blobdiff - vcsh

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Fix seed-gitignore, which was broken by the refactoring
[code/vcsh.git] / vcsh
diff --git a/vcsh b/vcsh
index 62310a7293ab5485839cccf1162d39b9acf184ff..0edfe2fc1ec818e9c3048c3e59344999f380b038 100755 (executable)
--- a/vcsh
+++ b/vcsh
@@ -1,55 +1,71 @@
 #!/bin/sh
 
-#set -x
+[ -n "$VCSH_DEBUG" ]      && set -x
+[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
+[ -z "$VCSH_BASE" ]       && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
 
 SELF=$(basename $0)
-[ -z $XDG_CONFIG_HOME ] && XDG_CONFIG_HOME="$HOME/.config"
-VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
+
 
 help() {
        echo "usage: $SELF <args>
 
-   help           Display this help
+   clone <remote> \\
+         [<repo>]       Clone from an existing repository
+   help                 Display this help text
+   delete               Delete an existing repository
+   init <repo>          Initialize a new repository
+   list                 List all repos
+   run <repo> \\
+       <command>        Use this repository
 
-   list           List all repos
+   seed-gitignore \\
+   <repo>               Seed .gitignore.d/<repo> from git ls-files
 
-   use <repo>     Use this repository
-   run <repo>
-       <command>  Use this repository
+   <repo> <git command> Special command that allows you to run git commands
+                        directly without having to type so much ;)" >&2
+#   use <repo>     Use this repository
+#
+#   exit              Exit vcsh mode" >&2
+}
 
-   init           Initialize a new repository
-   clone <remote>
-         [<repo>] Clone from an existing repository
+debug() {
+       [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
+}
 
-   exit           Exit vcsh mode" >&2
+verbose() {
+       if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
 }
 
 use() {
-       REPO_NAME="$1"
-       GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
-
+       verbose "use() begin"
        if [ ! -d "$GIT_DIR" ]; then
-               echo E: no repository found for "$REPO_NAME" >&2
-               return 2
+               echo E: no repository found for "$VCSH_REPO_NAME" >&2
+               return 1
        fi
-
        export GIT_DIR
        export GIT_WORK_TREE="$(git config --get core.worktree)"
-       export VCSH_DIRECTORY="$REPO_NAME"
+       export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+       verbose "use() end"
 }
 
 init() {
-       [[ -e $GIT_DIR ]] &&
+       verbose "init() begin"
+       [ -e "$GIT_DIR" ] &&
                echo "$SELF: fatal: $GIT_DIR exists" &&
                return 21
        export GIT_WORK_TREE="$HOME"
-       mkdir -p $GIT_WORK_TREE
-       cd $GIT_WORK_TREE ||
+       mkdir -p "$GIT_WORK_TREE"
+       cd "$GIT_WORK_TREE" ||
                (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
                 exit 20) || exit 20
-       cd $GIT_WORK_TREE
+       cd "$GIT_WORK_TREE"
        git init
-       git config core.worktree $GIT_WORK_TREE
+       git config core.worktree     "$GIT_WORK_TREE"
+       git config core.excludesfile ".gitignore.d/$REPO_NAME"
+       touch   "$HOME/.gitignore.d/$REPO_NAME"
+       git add "$HOME/.gitignore.d/$REPO_NAME"
+       verbose "init() end"
 }
 
 leave() {
@@ -58,77 +74,188 @@ leave() {
        unset VCSH_DIRECTORY
 }
 
-if [ "$1" = 'help' ] || [ $# -eq 0 ]; then
-       help
-       [ "$1" = 'help' ]
-       return $?
-
-elif [ "$1" = 'list' ]; then
-       for i in $VCSH_BASE/*.git; do
-               echo $(basename $i .git)
-       done
-       return 0
 
-elif [ "$1" = 'run' ]; then
-       use $2
+if [ "$1" = 'clone' ]; then
+       GIT_REMOTE="$2"
+       export GIT_REMOTE
+       VCSH_REPO_NAME="$3"
+       [ -z "$VCSH_REPO_NAME" ] && VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+       export VCSH_REPO_NAME
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+elif [ "$1" = 'delete' ] ||
+     [ "$1" = 'init' ] ||
+     [ "$1" = 'run' ]; then
+       [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
+       [ -z $3 ] && echo "$SELF $1 $2: error: please specify a command" && return 1
+       export VCSH_COMMAND="$1"
+       export VCSH_REPO_NAME="$2"
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
        shift 2
-       "$@"
-       leave
-       return 0
-
-elif [ "$1" = 'use' ]; then
-       if [[ -o NO_IGNORE_EOF ]]; then
-               export VCSH_NO_IGNORE_EOF=1
-               setopt IGNORE_EOF
-               vcsh_exit() {vcsh exit; zle reset-prompt;}
-               zle -N vcsh_exit
-               bindkey '^d' 'vcsh_exit'
+       export VCSH_EXTERNAL_COMMAND="$*"
+elif [ "$1" = 'seed-gitignore' ]; then
+       export VCSH_COMMAND="$1"
+       export VCSH_REPO_NAME="$2"
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+elif [ "$1" = 'help' ] ||
+     [ "$1" = 'list' ]; then
+       export VCSH_COMMAND="$1"
+else
+       [ -z $1 ] && help && return 0
+       export VCSH_COMMAND='run'
+       export VCSH_REPO_NAME="$1"
+       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+       [ -d $GIT_DIR ] || (help && return 1) || return 0
+       shift 1
+       export VCSH_EXTERNAL_COMMAND="git $*"
+fi
+
+
+for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
+do
+       if [ ! -d "$check_directory" ]; then
+               if [ -e "$check_directory" ]; then
+                       echo "$SELF: error: $check_directory exists but is not a directory" >&2
+                       exit 2
+               else
+                       echo "$SELF: info: attempting to create $check_directory"
+                       mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
+               fi
        fi
-       use $2
-       buildPS1
-       return 0
+done
 
-elif [ "$1" = 'clone' ]; then
-       GIT_REMOTE="$2"
-       REPO_NAME="$3"
-       [[ -z $REPO_NAME ]] && REPO_NAME=$(basename $GIT_REMOTE .git)
-       export REPO_NAME
-       export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
-       init
 
-       git remote add origin $GIT_REMOTE
+if [ "$VCSH_COMMAND" = 'clone' ]; then
+       verbose "clone begin"
+       init
+       git remote add origin "$GIT_REMOTE"
        git config branch.master.remote origin
        git config branch.master.merge  refs/heads/master
        git fetch
-       for i in $(git ls-tree -r origin/master | awk '{print $4}'); do
-       [[ -e $i ]] &&
-               echo "$SELF: error: $i exists." &&
-               CONFLICT=1;
+       for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
+               [ -e "$object" ] &&
+                       echo "$SELF: error: $object exists." &&
+                       VCSH_CONFLICT=1;
        done
-       [[ -n $CONFLICT ]] &&
+       [ "$VCSH_CONFLICT" = '1' ] &&
                echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
+               echo "  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
                exit 3
        git merge origin/master
-       vcsh use $REPO_NAME
+#      use || return 1
+       verbose "clone end"
+
+elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
+       help
+
+elif [ "$VCSH_COMMAND" = 'delete' ]; then
+       verbose "delete begin"
+       old_dir="$PWD"
+       cd "$HOME"
+       use || return 1
+       echo "$SELF: info: This operation WILL DETROY DATA!"
+       files=$(git ls-files)
+       echo "These files will be deleted:
+
+$files
+
+AGAIN, THIS WILL DELETE YOUR DATA!
+To continue, type \"Yes, do as I say\""
+       read answer
+       [ "x$answer" = "xYes, do as I say" ] || exit
+       for file in $files; do
+               rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
+       done
+       rm -rf "$GIT_DIR" || echo "$SELF: info: could not delete '$GIT_DIR'"
+       cd "$old_dir"
+       verbose "delete end"
+
+#elif [ "$VCSH_COMMAND" = 'exit' ]; then
+#      verbose "exit begin"
+#      if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
+#              unset VCSH_NO_IGNORE_EOF
+#              setopt NO_IGNORE_EOF
+#      fi
+#      leave
+#      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
+#      verbose "exit end"
+#      exit 0
 
-elif [ "$1" = 'init' ]; then
-       export REPO_NAME="$2"
-       export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
+elif [ "$VCSH_COMMAND" = 'init' ]; then
+       verbose "init begin"
        init
-       vcsh use $REPO_NAME
+#      use || return 1
+       verbose "init end"
 
-elif [ "$1" = 'exit' ]; then
-       if [[ $VCSH_NO_IGNORE_EOF -gt 0 ]]; then
-               unset VCSH_NO_IGNORE_EOF
-               setopt NO_IGNORE_EOF
-       fi
+elif [ "$VCSH_COMMAND" = 'list' ]; then
+       verbose "list begin"
+       for i in "$VCSH_BASE"/*.git; do
+               echo $(basename "$i" .git)
+       done
+       verbose "list end"
+
+elif [ "$VCSH_COMMAND" = 'run' ]; then
+       verbose "run begin"
+       use || return 1
+       $VCSH_EXTERNAL_COMMAND
        leave
-       buildPS1
-       return 0
+       verbose "run end"
+
+elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
+       verbose "seed-gitignore begin"
+       use || return 1
+       # Switching directory as this has to be executed from $HOME to be of any use.
+       # Going back into old directory at the end in case `vcsh use` is reactivated.
+       old_dir="$PWD"
+       cd "$HOME"
+       git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+       gitignores=$(for file in $(git ls-files); do
+               while true; do
+                       echo $file; new="${file%/*}"
+                       [ "$file" = "$new" ] && break
+                       file="$new"
+               done;
+       done | sort -u | sed 's/^/!/')
+       tempfile=$(mktemp) ||
+               (echo "$SELF: fatal: could not create tempfile" && exit 1) 
+       echo '*' > "$tempfile"
+       for gitignore in $gitignores; do
+               echo "$gitignore" >> "$tempfile"
+       done
+       diff -N "$tempfile" "$HOME/.gitignore.d/$2" > /dev/null &&
+               rm -f "$tempfile" &&
+               return
+       if [ -e "$HOME/.gitignore.d/$2" ]; then
+               echo "$SELF: info: $HOME/.gitignore.d/$2 differs from new data, moving it to $HOME/.gitignore.d/$2.bak"
+               mv -f "$HOME/.gitignore.d/$2" "$HOME/.gitignore.d/$2.bak" ||
+                       (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$2 to $HOME/.gitignore.d/$2.bak" && exit 1)
+       fi
+       mv -f "$tempfile" "$HOME/.gitignore.d/$2" ||
+               (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$2" && exit 1)
+       cd "$old_dir"
+       verbose "seed-gitignore end"
+
+#elif [ "$VCSH_COMMAND" = 'use' ]; then
+#      verbose "use begin"
+#      if [ -n "$ZSH_VERSION" ]; then
+#              if [ -o NO_IGNORE_EOF ]; then
+#                      export VCSH_NO_IGNORE_EOF=1
+#                      setopt IGNORE_EOF
+#              fi
+#              vcsh_exit() {
+#                      vcsh exit;
+#                      zle reset-prompt;
+#              }
+#              zle -N vcsh_exit
+#              bindkey '^d' 'vcsh_exit'
+#      fi
+#      use || return 1
+#      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
+#      verbose "use end"
 
 else
+       verbose "defaulting to calling help()"
        help
-       return 3
+       echo "$SELF: fatal: You should never reach this code. File a bug, please."
+       exit 99
 
 fi
-